/**
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.scheme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.xtext.example.mydsl.scheme.Any;
import org.xtext.example.mydsl.scheme.Conditional;
import org.xtext.example.mydsl.scheme.SchemePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Conditional</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.ConditionalImpl#getCond <em>Cond</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.ConditionalImpl#getTruthy <em>Truthy</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.ConditionalImpl#getFalsy <em>Falsy</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ConditionalImpl extends CommandImpl implements Conditional
{
  /**
   * The cached value of the '{@link #getCond() <em>Cond</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCond()
   * @generated
   * @ordered
   */
  protected Any cond;

  /**
   * The cached value of the '{@link #getTruthy() <em>Truthy</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTruthy()
   * @generated
   * @ordered
   */
  protected Any truthy;

  /**
   * The cached value of the '{@link #getFalsy() <em>Falsy</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFalsy()
   * @generated
   * @ordered
   */
  protected Any falsy;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConditionalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchemePackage.Literals.CONDITIONAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Any getCond()
  {
    return cond;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCond(Any newCond, NotificationChain msgs)
  {
    Any oldCond = cond;
    cond = newCond;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.CONDITIONAL__COND, oldCond, newCond);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setCond(Any newCond)
  {
    if (newCond != cond)
    {
      NotificationChain msgs = null;
      if (cond != null)
        msgs = ((InternalEObject)cond).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.CONDITIONAL__COND, null, msgs);
      if (newCond != null)
        msgs = ((InternalEObject)newCond).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.CONDITIONAL__COND, null, msgs);
      msgs = basicSetCond(newCond, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.CONDITIONAL__COND, newCond, newCond));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Any getTruthy()
  {
    return truthy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetTruthy(Any newTruthy, NotificationChain msgs)
  {
    Any oldTruthy = truthy;
    truthy = newTruthy;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.CONDITIONAL__TRUTHY, oldTruthy, newTruthy);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setTruthy(Any newTruthy)
  {
    if (newTruthy != truthy)
    {
      NotificationChain msgs = null;
      if (truthy != null)
        msgs = ((InternalEObject)truthy).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.CONDITIONAL__TRUTHY, null, msgs);
      if (newTruthy != null)
        msgs = ((InternalEObject)newTruthy).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.CONDITIONAL__TRUTHY, null, msgs);
      msgs = basicSetTruthy(newTruthy, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.CONDITIONAL__TRUTHY, newTruthy, newTruthy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Any getFalsy()
  {
    return falsy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFalsy(Any newFalsy, NotificationChain msgs)
  {
    Any oldFalsy = falsy;
    falsy = newFalsy;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemePackage.CONDITIONAL__FALSY, oldFalsy, newFalsy);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setFalsy(Any newFalsy)
  {
    if (newFalsy != falsy)
    {
      NotificationChain msgs = null;
      if (falsy != null)
        msgs = ((InternalEObject)falsy).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SchemePackage.CONDITIONAL__FALSY, null, msgs);
      if (newFalsy != null)
        msgs = ((InternalEObject)newFalsy).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SchemePackage.CONDITIONAL__FALSY, null, msgs);
      msgs = basicSetFalsy(newFalsy, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.CONDITIONAL__FALSY, newFalsy, newFalsy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SchemePackage.CONDITIONAL__COND:
        return basicSetCond(null, msgs);
      case SchemePackage.CONDITIONAL__TRUTHY:
        return basicSetTruthy(null, msgs);
      case SchemePackage.CONDITIONAL__FALSY:
        return basicSetFalsy(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchemePackage.CONDITIONAL__COND:
        return getCond();
      case SchemePackage.CONDITIONAL__TRUTHY:
        return getTruthy();
      case SchemePackage.CONDITIONAL__FALSY:
        return getFalsy();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchemePackage.CONDITIONAL__COND:
        setCond((Any)newValue);
        return;
      case SchemePackage.CONDITIONAL__TRUTHY:
        setTruthy((Any)newValue);
        return;
      case SchemePackage.CONDITIONAL__FALSY:
        setFalsy((Any)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.CONDITIONAL__COND:
        setCond((Any)null);
        return;
      case SchemePackage.CONDITIONAL__TRUTHY:
        setTruthy((Any)null);
        return;
      case SchemePackage.CONDITIONAL__FALSY:
        setFalsy((Any)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.CONDITIONAL__COND:
        return cond != null;
      case SchemePackage.CONDITIONAL__TRUTHY:
        return truthy != null;
      case SchemePackage.CONDITIONAL__FALSY:
        return falsy != null;
    }
    return super.eIsSet(featureID);
  }

} //ConditionalImpl
